#include <iostream>
using namespace std;

int t[1001]; // t[i] = timpul necesar muncintorului i pt a impacheta un obiect
int n, m;

void CitesteDate();
int Cb(); // returneaza timpul minim necesar celor n muncitori pentru a
          // impacheta m obiecte
bool Check(int T);

int main()
{
	CitesteDate();
	
	cout << Cb();
}

int Cb()
{	// intervalul posibil pt timp
	int st = 1, dr = 1e9, mid; // timpi
	int tmin = 1e9;     // Tmax = 1e9
	while (st <= dr)   // O(n * Log(Tmax)) 
	{
		mid = (st + dr) / 2;
		
		if (Check(mid)) // O(n)
		{
			tmin = mid;
			dr = mid - 1;
		}
		else
			st = mid + 1;
	}
	return tmin;
}

bool Check(int T)
{
	int nrob = 0;
	for (int i = 1; i <= n; ++i)
	{
		nrob += T / t[i];
		if (nrob >= m)
			return true;
	}
	
	return false;
}

void CitesteDate()
{
	cin >> n >> m;
	for (int i = 1; i <= n; ++i)
		cin >> t[i];
}
