#include <iostream>
#include <algorithm>
using namespace std;

const int Dim = 100001;
int a[Dim];
int b[Dim]; // contine unicate
int c[Dim]; // c[i] nr de valori egale cu a[i] unde i e poz in sirul b[]
int k = 1;  // nr elem in b[]

int p2[31];
int n;

void CitesteDate();
void Init();
int Cb(int i, int val);
void Solve();

int main()
{
	CitesteDate();
	Init();
	Solve();
}

void Solve()
{
	sort (a + 1, a + n + 1); // O(n * log(n))
	
	// in b[] plasam unicatele din a[]
	
	b[1] = a[1];
	c[1] = 1;
	for (int i = 2; i <= n; ++i)
		if (a[i] == a[i - 1])
			c[k]++;          // k poz curenta in sirul b[]
		else
		{
			b[++k] = a[i];
			c[k] = 1;
		}
	
	long long res = 0;
	for (int p = 0; p < 31; ++p) // p2[1] = 2
		for (int i = 1; i <= k; ++i)
		{
			if ( b[i] == p2[p])
				res += 1LL * c[i] * (c[i] - 1) / 2;
			// b[i] + b[j] == p2[p]
			int j = Cb(i + 1, p2[p] - b[i]);
			if (j != -1)
				res += 1LL * c[i] * c[j];
		}
		
	cout << res;
}

int Cb(int i, int val)
{
	int st = i, dr = k, m; // pozitii in sirul b[]
	
	while (st <= dr)
	{
		m = (st + dr) / 2;
		if (b[m] == val)
			return m;
			
		if (val > b[m])
			st = m + 1;
		else
			dr = m - 1;
	}
	
	return -1;
}


void Init()
{
	p2[0] = 1;
	for (int i = 1; i <= 30; ++i)
		p2[i] = p2[i - 1] * 2;
}

void CitesteDate()
{
	cin >> n;
	for (int i = 1; i <= n; ++i)
		cin >> a[i];
}




