#include <iostream>
#include <fstream>
using namespace std;


ifstream fin("maraton.in");
ofstream fout("maraton.out");

const int MaxX = 100000;

int cnt[MaxX + 5]; // cnt[t] nr de maratonisti care ajung la finish exact in timpul t

int main() 
{
    int n, Q, x, v;
    
    fin >> n;
    int timp;
    for (int i = 0; i < n; ++i)  // O(n)
    {
        fin >> x >> v;
        timp = x / v;
        if (x % v)
			timp++;
        cnt[timp]++;
    }
    
    // O(n)
    for (int t = 1; t <= MaxX; ++t) // numarul de maratonisti care ajung pana la momentul t
        cnt[t] += cnt[t - 1];
        
    fin >> Q;
    for (int i = 0; i < Q; ++i) // O(Q) = O(n)
    {
        fin >> timp;
        fout << cnt[timp] << '\n';
    }
    
    
    return 0;
}
 
